/*
 *  Copyright (C) 2025 Texas Instruments Incorporated
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
/**
 * \ingroup TISCI
 * \defgroup tisci_lpm_enc_dec tisci_lpm_enc_dec
 *
 * DMSC controls the power management, security and resource management
 * of the device.
 *
 *
 * @{
 */
/**
 *
 *  \brief  This file contains:
 *
 *          WARNING!!: Autogenerated file from SYSFW. DO NOT MODIFY!!
 * System Firmware
 *
 * TISCI Data structures and macros for LPM encryption and decryption
 *
 */

#ifndef TISCI_LPM_ENC_DEC_H_
#define TISCI_LPM_ENC_DEC_H_


/**
 * \brief Request for TISCI_MSG_LPM_ENCRYPT.
 *
 * \param hdr TISCI header to provide ACK/NAK flags to the host.
 * \param unencrypted_addr MSMC source address where the unencrypted binary is placed
 * \param encrypted_addr DDR destination address where the [context + encrypted metadata + encrypted binary] should be placed
 * \param unencrypted_len The size of the unencrypted binary present in the MSMC
 * \param max_encrypted_len The maximum possible size allowed for storing the [context + encrypted metadata + encrypted binary]
 *
 */
struct tisci_msg_enc_req {
    struct tisci_header    hdr;
    uint64_t            unencrypted_addr;
    uint64_t            encrypted_addr;
    uint32_t            unencrypted_len;
    uint32_t            max_encrypted_len;
} __attribute__((__packed__));

/**
 * \brief Response for TISCI_MSG_LPM_ENCRYPT.
 *
 * \param hdr TISCI header to provide ACK/NAK flags to the host.
 *
 */
struct tisci_msg_enc_resp {
    struct tisci_header hdr;
} __attribute__((__packed__));

/**
 * \brief Request for TISCI_MSG_LPM_DECRYPT.
 *
 * \param hdr TISCI header to provide ACK/NAK flags to the host.
 * \param unencrypted_addr MSMC destination address where the unencrypted binary should be placed
 * \param encrypted_addr DDR source address where the [context + encrypted metadata + encrypted binary] is placed
 *
 */
struct tisci_msg_dec_req {
    struct tisci_header    hdr;
    uint64_t            unencrypted_addr;
    uint64_t            encrypted_addr;
} __attribute__((__packed__));

/**
 * \brief Response for TISCI_MSG_LPM_DECRYPT.
 *
 * \param hdr TISCI header to provide ACK/NAK flags to the host.
 *
 */
struct tisci_msg_dec_resp {
    struct tisci_header hdr;
} __attribute__((__packed__));

#endif /* TISCI_LPM_ENC_DEC_H_ */

/* @} */
